PROGRAM UnPAWs;


USES Z80load;

(***************************************************************************)
(*                                                                         *)
(*  Professional Adventure Writing System extractor.                       *)
(*  Author: Jose Luis Cebrin Page                                      *)
(*  Pascal version : Carlos Sanchez (csanchez@temple.subred.org)           *)
(*                                                                         *)
(***************************************************************************)
(*                                                                         *)
(*  Z80 files support and other minor changes added by Carlos Sanchez      *)
(*  when translating the code from C to pascal                             *)
(*                                                                         *)
(***************************************************************************)
(* Linux version compilable under gpc 2.91.60-5                            *)
(*									   *)
(* 27/12/1999 some minor changes added to make it compilable under linux   *)
(***************************************************************************)


{$I-}

TYPE String255 = String[255];

CONST Version = '0.2 Beta';
      MAXTVOC=6;

VAR Spectrum : ARRAY [16384..65535] OF Byte;
    FOut : Text;
    F : File;
    FSize : Longint;
    VocPtr, ConPtr, ProPtr, ResPtr : Word;
    i, n, p : Integer;
    InputFileName, OutPutFileName : String255;
    OffAbreviaturas: Word;
    OffVoc, offcon, OffMsg, OffSys, OffLoc, OffObj, OffWObj,
    OffLObj, OffXObj, OffPro: Word;
    NumLoc, NumMsg, NumSys, NumObj, NumPro : Integer ;
    AbrevOn:Boolean;
    S:String255;

TYPE COND= Record
            Condact:String[20];
            Params:Integer
           End;


CONST Condacts:ARRAY [0..107] OF COND=(
(Condact:'AT';Params:1),
(Condact:'NOTAT';Params:1),
(Condact:'ATGT';Params:1),
(Condact:'ATLT';Params:1),
(Condact:'PRESENT';Params:1),
(Condact:'ABSENT';Params:1),
(Condact:'WORN';Params:1),
(Condact:'NOTWORN';Params:1),
(Condact:'CARRIED';Params:1),
(Condact:'NOTCARR';Params:1),
(Condact:'CHANCE';Params:1),
(Condact:'ZERO';Params:1),
(Condact:'NOTZERO';Params:1),
(Condact:'EQ';Params:2),
(Condact:'GT';Params:2),
(Condact:'LT';Params:2),
(Condact:'ADJECT1';Params:1),
(Condact:'ADVERB';Params:1),
(Condact:'INVEN';Params:0),
(Condact:'DESC';Params:0),
(Condact:'QUIT';Params:0),
(Condact:'END';Params:0),
(Condact:'DONE';Params:0),
(Condact:'OK';Params:0),
(Condact:'ANYKEY';Params:0),
(Condact:'SAVE';Params:0),
(Condact:'LOAD';Params:0),
(Condact:'TURNS';Params:0),
(Condact:'SCORE';Params:0),
(Condact:'CLS';Params:0),
(Condact:'DROPALL';Params:0),
(Condact:'AUTOG';Params:0),
(Condact:'AUTOD';Params:0),
(Condact:'AUTOW';Params:0),
(Condact:'AUTOR';Params:0),
(Condact:'PAUSE';Params:1),
(Condact:'TIEMOUT';Params:0),
(Condact:'GOTO';Params:1),
(Condact:'MESSAGE';Params:1),
(Condact:'REMOVE';Params:1),
(Condact:'GET';Params:1),
(Condact:'DROP';Params:1),
(Condact:'WEAR';Params:1),
(Condact:'DESTROY';Params:1),
(Condact:'CREATE';Params:1),
(Condact:'SWAP';Params:2),
(Condact:'PLACE';Params:2),
(Condact:'SET';Params:1),
(Condact:'CLEAR';Params:1),
(Condact:'PLUS';Params:2),
(Condact:'MINUS';Params:2),
(Condact:'LET';Params:2),
(Condact:'NEWLINE';Params:0),
(Condact:'PRINT';Params:1),
(Condact:'SYSMESS';Params:1),
(Condact:'ISAT';Params:2),
(Condact:'COPYOF';Params:2),
(Condact:'COPYOO';Params:2),
(Condact:'COPYFO';Params:2),
(Condact:'COPYFF';Params:2),
(Condact:'LISTOBJ';Params:0),
(Condact:'EXTERN';Params:1),
(Condact:'RAMSAVE';Params:0),
(Condact:'RAMLOAD';Params:1),
(Condact:'BEEP';Params:2),
(Condact:'PAPER';Params:1),
(Condact:'INK';Params:1),
(Condact:'BORDER';Params:1),
(Condact:'PREP';Params:1),
(Condact:'NOUN2';Params:1),
(Condact:'ADJECT2';Params:1),
(Condact:'ADD';Params:2),
(Condact:'SUB';Params:2),
(Condact:'PARSE';Params:0),
(Condact:'LISTAT';Params:1),
(Condact:'PROCESS';Params:1),
(Condact:'SAME';Params:2),
(Condact:'MES';Params:1),
(Condact:'CHARSET';Params:1),
(Condact:'NOTEQ';Params:2),
(Condact:'NOTSAME';Params:2),
(Condact:'MODE';Params:2),
(Condact:'LINE';Params:1),
(Condact:'TIME';Params:2),
(Condact:'PICTURE';Params:1),
(Condact:'DOALL';Params:1),
(Condact:'PROMPT';Params:1),
(Condact:'GRAPHIC';Params:1),
(Condact:'ISNOTAT';Params:2),
(Condact:'WEIGH';Params:2),
(Condact:'PUTIN';Params:2),
(Condact:'TAKEOUT';Params:1),
(Condact:'NEWTEXT';Params:0),
(Condact:'ABILITY';Params:2),
(Condact:'WEIGHT';Params:1),
(Condact:'RANDOM';Params:1),
(Condact:'INPUT';Params:1),
(Condact:'SAVEAT';Params:0),
(Condact:'BACKAT';Params:0),
(Condact:'PRINTAT';Params:2),
(Condact:'WHATO';Params:0),
(Condact:'RESET';Params:1),
(Condact:'PUTO';Params:1),
(Condact:'NOTDONE';Params:0),
(Condact:'AUTOP';Params:1),
(Condact:'AUTOT';Params:1),
(Condact:'MOVE';Params:1),
(Condact:'PROTECT';Params:0));

CONST tVocs:ARRAY [0..6] OF String255=(
'Verb',
'Adverb',
'Noun',
'Adjetive',
'Preposition',
'Conj.',
'Pronoun');

FUNCTION DPeek(C:Word):Word;
BEGIN
 DPeek := spectrum[c] OR (spectrum[c+1] SHL 8);
END;

FUNCTION Peek(C:Word):Byte;
BEGIN
 Peek := Spectrum[c];
END;

FUNCTION PeekNeg(C:Word):Byte;
BEGIN
 PeekNeg := Spectrum[c] XOR 255;
END;

FUNCTION Select(Option:Boolean;S1,S2:String255):String255;
(* Emulates ? operator (C language) *)
BEGIN
 IF Option THEN Select:=S1
           ELSE Select:=S2;
END;

FUNCTION Justify(S : String255; N: Byte) : String255;
BEGIN
 WHILE Length(S)<N DO S:=S+' ';
 JustiFy := S;
END;

FUNCTION IntToStr(L:Longint):String255;
VAR S : String255;
BEGIN
 Str(L,S);
 IntToStr := S
END;

PROCEDURE Error(n:Byte);
BEGIN
 IF N<>0 THEN Write('Error: ');
 CASE N OF
  1:WriteLn('File not found.');
  2:WriteLn('Must be a .SP, .SNA or .Z80 file.');
  3:WriteLn('It doesn''t seem to be a PAW game.');
  4:WriteLn('Parameter missing.');
  5:WriteLn('The .Z80 format version of this file is not valid.');
  6:WriteLn('The .Z80 file is not a 48K snapshot.');
 END;
 Halt(n)
END;

FUNCTION Abreviatura(c:Integer) : String255;
VAR Offs: Word;
    S:String255;
BEGIN
 S:='';
 Offs:=OffAbreviaturas;
 Dec(c,164);
 WHILE c<>0 DO
  BEGIN
   WHILE (Spectrum[Offs] AND 128) = 0 DO Inc(Offs);
   Inc(Offs);
   Dec(c);
  END;
  WHILE (Spectrum[Offs] AND 128) = 0 DO BEGIN
                                         S := S + Char(Spectrum[Offs]);
                                         Inc(Offs);
                               END;
  S := S + Char(Spectrum[Offs] AND 127);
  Abreviatura:= S;
END;

FUNCTION Tipo_Voc(C:Integer):String255;
BEGIN
 IF (C>=0) AND (C<=MAXTVOC) then Tipo_Voc:=TVocs[c]
                            else Tipo_Voc:='RESERVED';
END;

FUNCTION Palabra(Num, Tipo : Integer) : String255;
VAR VocPtr: Word;
    Pal:String255;
BEGIN
 VocPtr:=OffVoc;
 Pal := '     ';
 WHILE Peek(VocPtr)<>0 do
  BEGIN
   IF (Peek(vocptr+5) = Num) AND (Peek(vocptr+6) = Tipo) THEN
    BEGIN
     pal[1]:=char(PeekNeg(VocPtr));
     pal[2]:=char(PeekNeg(VocPtr+1));
     pal[3]:=char(PeekNeg(VocPtr+2));
     pal[4]:=char(PeekNeg(VocPtr+3));
     pal[5]:=char(PeekNeg(VocPtr+4));
     Palabra:=Pal;
     Exit;
    END;
   Inc(VocPtr,7);
  END;
 Palabra:='';
END;

PROCEDURE Ver_String(S : String255);
VAR I:Byte;
BEGIN
 FOR I:=1 TO Length(S) DO
  BEGIN
   IF S[I]=#7 THEN Write(FOut,'^') ELSE
   IF (S[I]>#31) AND (S[I]<>'^')
     AND (S[I]<>'"') AND (S[I]<#164)
      THEN Write(FOut,S[I])
      ELSE Write(FOut,'{',Byte(S[I]),'}');
  END;
END;

PROCEDURE Ver_Mensajes(Titulo:String255; Offtab:Word; Num:Integer);
VAR I:Integer;
    C: Byte;
    Offs:Word;
BEGIN
 I:=0;
 WHILE I<Num DO
  BEGIN
   Offs:=DPeek(OffTab+2*i);
   WriteLn(FOut,Titulo,' ',i:3,'  ');
   Inc(I);
   WHILE (Spectrum[Offs] <> (31 XOR $FF)) AND (Offs<65520) DO
    BEGIN
     C:=PeekNeg(Offs);
     Inc(Offs);
     IF C=7 THEN Write(FOut,'^');
     IF (C>31) AND (C<>byte('^'))
      AND (C<>Byte('"')) AND (C<164) THEN Write(FOut,Char(c)) ELSE
     IF (C>=164) AND (C<=255) THEN Ver_String(Abreviatura(c))
                              ELSE Write(FOut,'{',C,'}');

    END;
   Inc(Offs);
   WriteLn(FOut);
   WriteLn(FOut);
  END;
END;



FUNCTION UpSt(S:String255):String255;
VAR I:Byte;
BEGIN
 FOR I:=1 TO Length(S) DO
  S[I]:=UpCase(S[I]);
 UpSt:=S;
END;


PROCEDURE Sintax;
BEGIN
 WriteLn;
 WriteLn('SINTAX:  UNPAWS -I<filename> [-O<filename>] [-A]');
 WriteLn;
 WriteLn('-I must be a .SP, .SNA or .Z80 file');
 WriteLn;
 WriteLn('-O Text file where the output is written. If you don''t include');
 WriteLn('   this parameter results will be sent to standar output.');
 WriteLn;
 WriteLn('-A Include compress (PAW database compression) information.');
 WriteLn;
 WriteLn('Example :     UNPAWS -IRIPPER1.Z80 -ORIPPER1.DB -A');
 WriteLn;
 Halt;
END;

PROCEDURE CheckParameters;
VAR I:Byte;
    S:String255;
BEGIN
 IF ParamCount=0 THEN Sintax;

 InputFileName:='';
 OutPutFileName:='';
 AbrevOn:=False;
 FOR I:=1 TO ParamCount DO
  BEGIN
   S:=UpSt(ParamStr(I));
   IF Copy(S,1,2)='-I' THEN InputFileName:=Copy(S,3,255);
   IF Copy(S,1,2)='-O' THEN OutputFileName:=Copy(S,3,255);
   IF Copy(S,1,2)='-A' THEN AbrevOn:=True;
  END;
 IF InputFileName='' THEN Sintax;
END;


BEGIN (* main *)
 WriteLn('UNPAWS ',Version);

 (* Load parameters *)
 CheckParameters;

 (* Load File *)
 Assign(F,InputFileName);
 Reset(F,1);
 IF IOResult<>0 THEN Error(1);
 FSize:=FileSize(F);
 IF FSize=49179 THEN
         BEGIN
          Seek(F,7195);
          BlockRead(F,Spectrum[23552],41984);
         END ELSE
 IF FSize=49190 THEN
         BEGIN
          Seek(F,7206);
          BlockRead(F,Spectrum[23552],41984);
         END
  ELSE IF Pos('.Z80',InPutFileName)<>0 THEN CASE LoadZ80(InputFileName,Spectrum) OF
                                             1:Error(5);
                                             2:Error(6);
                                            END
  ELSE Error(2);
 Close(F);

 (* Analize *)

 IF Peek(37943) <> 16 THEN Error(3);

 (* Open output file *)
 Assign(FOut,OutputFileName);
 Rewrite(FOut);
 WriteLn(FOut);


 (* Global data *)
 OffMsg:=DPeek(65503);
 NumMsg:=Peek(37958);
 OffSys:=DPeek(65505);
 NumSys:=Peek(37959);
 OffLoc:=DPeek(65501);
 NumLoc:=Peek(37957);
 OffObj := DPeek(65499);
 NumObj := Peek(37956);
 NumPro := Peek(37960) ;
 OffPro := DPeek(65497) ;
 OffAbreviaturas := DPeek(37964) ;

 WriteLn;
 WriteLn('Analizando [',Copy(InputFileName,1,Pos('.',InputFileName)-1),']');

 (* System colors *)
 WriteLn(FOut,'PAW Database : ',InputFileName);
 WriteLn(FOut);
 WriteLn(FOut,'Extracted by Unpaws '+ version);
 WriteLn(FOut);
 WriteLn('Checking general data...');
 WriteLn(FOut,'General data');
 WriteLn(FOut,'------------');
 WriteLn(FOut);
 WriteLn(FOut,'Locations                   ', NumLoc:10);
 WriteLn(FOut,'Ojects                      ', NumObj:10);
 WriteLn(FOut,'Messages                    ', NumMsg:10);
 WriteLn(FOut,'System messages             ', NumSys:10);
 WriteLn(FOut,'Processes                   ', NumPro:10);
 WriteLn(FOut,'Default ink color           ', Peek(37944):10) ;
 WriteLn(FOut,'Default paper color         ', Peek(37946):10) ;
 WriteLn(FOut,'Default flash state         ', Peek(37948):10) ;
 WriteLn(FOut,'Default bright state        ', Peek(37950):10) ;
 WriteLn(FOut,'Default inverse state       ', Peek(37952):10) ;
 WriteLn(FOut,'Default border color        ', Peek(37955):10) ;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 WriteLn('Extracting vocabulary');
 (* Vocabulary *)
 WriteLn(FOut,'Vocabulary');
 WriteLn(FOut,'----------');

 vocptr := DPeek(65509);
 OffVoc := DPeek(65509);

 WHILE (vocptr < 65509) AND  (Peek(vocptr)<>0) DO
 BEGIN
  WriteLn(FOut,char(PeekNeg(vocptr)),char(PeekNeg(vocptr+1)),
         char(PeekNeg(vocptr+2)),char(PeekNeg(vocptr+3)),char(PeekNeg(vocptr+4)),
         Peek(vocptr+5):5,tipo_voc(Peek(vocptr+6)));
  VocPtr := VocPtr + 7 ;
 END;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Messages *)
 WriteLn(FOut,'MESSAGES');
 WriteLn(FOut,'--------');
 WriteLn('Extracting ',NumMsg, ' message(s)');
 Ver_mensajes ('Message', OffMsg, nummsg);
 WriteLn(FOut);


 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* System messages *)
 WriteLn(FOut,'SYSTEM MESSAGES');
 WriteLn(FOut,'---------------') ;
 WriteLn('Extracting ',NumSys,' system menssge(s)');
 ver_mensajes ('Message', offsys, numsys) ;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Location descriptions *)
 WriteLn(FOut,'LOCATIONS');
 WriteLn(FOut,'---------');
 WriteLn('Extracting ',NumLoc,' location(s)');
 Ver_mensajes ('Location', offloc, NumLoc) ;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Conecctions *)
 WriteLn(FOut,'CONNECTIONS');
 WriteLn(FOut,'-----------') ;
 WriteLn('Extracting connections');
 offcon := DPeek(65507) ;
 FOR i:=0 TO numloc-1 DO
  BEGIN
   conptr := DPeek(offcon+2 * i) ;
   n := 0 ;
   WHILE Peek(conptr) <> 255 DO
     BEGIN
      S := palabra(Peek(conptr), 0);
      if S='' then S := palabra (Peek(conptr), 2) ;
      if n=0 THEN Write(FOut,'Location ',i:3,':  ')
             ELSE Write(FOut,'                ') ;
      n := n+ 1;
      if S<>'' then WriteLn(FOut,S,' ',Peek(conptr+1))
               else WriteLn(FOut,Peek(conptr),' ',Peek(conptr+1));
      conptr :=conptr+ 2 ;
     END;
     IF n<>0 THEN WriteLn(FOut);
  END;

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Object names *)
 WriteLn(FOut,'OBJECT NAMES');
 WriteLn(FOut,'------------');
 WriteLn('Extracting ',NumObj,' object(s)');
 ver_mensajes ('Object',OffObj , NumObj);
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Object words *)
 WriteLn('Extracting object words');
 WriteLn(FOut,'OBJECT WORDS');
 WriteLn(FOut,'------------') ;
 offwobj := DPeek(65513) ;
 FOR I:=0 TO NumObj-1 DO
 BEGIN
     S := palabra(Peek(offwobj+2*i), 2) ;
     if S<>'' THEN S:=S + ' ' + IntToStr(Peek(offwobj+2*i));
     if (Peek(offwobj+2*i) = 255) THEN S:=S+'_    ' ;
     Write(FOut,'Object ',i:3,'    ',S,' ') ;
     S := palabra(Peek(offwobj+2*i+1), 3) ;
     if S<>'' THEN S := S + ' '+IntToStr( Peek(offwobj+2*i+1));
     if (Peek(offwobj+2*i+1) = 255) then S := S+'_    ';
     WriteLn(FOut,S) ;
 END;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Objects "Initialy at" *)
 WriteLn('Extracting Initialy At');
 WriteLn(FOut,'INITIALY AT');
 WriteLn(FOut,'-----------');
 OffLObj := DPeek(65511) ;
 for i:=0 TO NumObj-1 DO
   CASE (Peek(offlobj+i)) OF
    252:WriteLn(FOut,'Object ',i:3,'    NC');
    253:WriteLn(FOut,'Object ',i:3,'    W');
    254:WriteLn(FOut,'Objeto ',i:3,'    C')
    ELSE WriteLn(FOut,'Objeto ',i:3,'    ',Peek(offlobj+i));
   END;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Objects weight and type *)
 WriteLn('Extracting objects weight and type');
 WriteLn(FOut,'OBJECT WEIGHT AND TYPE');
 WriteLn(FOut,'----------------------') ;
 offxobj := DPeek(65515) ;
 for I:=0 TO NumObj-1 DO
    WriteLn(FOut,'Object ',i:3,':  weights ',
      Peek(offxobj+i) AND 63:3,'    ',
       Select((Peek(offxobj+i) AND 64)<>0,'C','          '),' ',
        Select((Peek(offxobj+i) AND 128)<>0,'W','      '));
 WriteLn(FOut);


 (* Processes *)
 WriteLn('Extracting Process/Response tables');
 FOR P:=0 TO NumPro-1 DO
 BEGIN
  WriteLn(FOut,'--------------------------------------------------------------------------');
  WriteLn(FOut);
  IF (p=0) THEN BEGIN
                 WriteLn(FOut,'RESPONSE TABLE');
                 WriteLn(FOut,'--------------')
                END
           ELSE BEGIN
                 WriteLn(FOut,'PROCESS ',p:3);
                 WriteLn(FOut,'-----------');
                END;

   proptr := DPeek(offpro+p*2) ;
   while (Peek(proptr)<>0) DO
     BEGIN
         S := palabra (Peek(proptr), 0) ;
         if (Peek(proptr) = 1) then S := S + '*    '
         else
         if (Peek(proptr) = 255) then S := S + '_    ';
         if S='' THEN
          BEGIN
             if (Peek(proptr) < 20) then
                 S := palabra(Peek(proptr), 2);
             if S = '' THEN S := IntToStr(Peek(proptr)) ;
          END;
         Write(FOut,S,' ') ;
         proptr := proptr + 1 ;
         S := palabra (Peek(proptr), 2) ;
         if (Peek(proptr) = 1) then S := S + '*    '
         else
         if (Peek(proptr) = 255) then S := S + '_    ';
         if S = '' THEN
          BEGIN
             if (Peek(proptr) < 20) then
                 S := palabra(Peek(proptr), 2);
             if S='' THEN S:=IntToStr(Peek(proptr)) ;
          END;
         Write(FOut,S,'      ') ;
         proptr := proptr +1 ;

         resptr := DPeek(proptr) ;
         proptr := proptr + 2 ;

         n := 0 ;
         while (Peek(resptr) <> 255) do
         BEGIN
           if (n<>0) then Write(FOut,'                 ') ;
           n := n + 1;
           if (Peek(resptr) <= 107) THEN
             BEGIN
                 Write(FOut,Justify(condacts[Peek(resptr)].condact,12));
                 if (condacts[Peek(resptr)].params > 0) THEN
                     Write(FOut,' ',Peek(resptr+1):3);
                 if (condacts[Peek(resptr)].params > 1) THEN
                     Write(FOut,' ',Peek(resptr+2):3);
                 resptr :=resptr + condacts[Peek(resptr)].params;
             END;
             resptr := resptr + 1 ;
             WriteLn(FOut);
         END;
         WriteLn(FOut);
     END;
     WriteLn(FOut);
 END;


 IF AbrevOn THEN
  BEGIN
   WriteLn(FOut,'--------------------------------------------------------------------------');
   WriteLn(FOut);
   (* Compression data *)
   WriteLn('Extracting compression data');
   WriteLn(FOut,'Compression data');
   WriteLn(FOut,'----------------');
   FOR I:=164 TO 254 DO
       WriteLn(FOut,'Compression ',I:2,': ',Abreviatura(I));
   WriteLn(FOut);
  END;

 WriteLn('Ok. Finished.');
 Close(FOut);
END.
